package subaraki.petbuddy.mod;

import java.util.Arrays;

import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.Mod.EventHandler;
import net.minecraftforge.fml.common.ModMetadata;
import net.minecraftforge.fml.common.SidedProxy;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.network.NetworkRegistry;
import subaraki.petbuddy.capability.PetInventoryCapability;
import subaraki.petbuddy.gui.GuiHandler;
import subaraki.petbuddy.gui.handler.KeyHandler;
import subaraki.petbuddy.hooks.CoolDownTracker;
import subaraki.petbuddy.hooks.PlayerTracker;
import subaraki.petbuddy.hooks.StowOrSummonLogic;
import subaraki.petbuddy.network.NetworkHandler;
import subaraki.petbuddy.proxy.ServerProxy;

@Mod(modid = PetBuddy.MODID, name = PetBuddy.NAME, version = PetBuddy.VERSION, dependencies = PetBuddy.DEPENDENCY)
public class PetBuddy {

	public static final String MODID = "petbuddy";
	public static final String NAME = "Pet Buddy";
	public static final String VERSION = "1.11 2.3.1.8";
	public static final String DEPENDENCY = "required-after:subcommonlib";

	private static final String client = "subaraki.petbuddy.proxy.ClientProxy";
	private static final String server = "subaraki.petbuddy.proxy.ServerProxy";

	@SidedProxy(clientSide = PetBuddy.client, serverSide = PetBuddy.server)
	public static ServerProxy proxy;

	public static PetBuddy instance;
	
	@EventHandler
	public void preinit(FMLPreInitializationEvent event) {
		ModMetadata modMeta = event.getModMetadata();
		modMeta.authorList = Arrays.asList(new String[] { "Subaraki" });
		modMeta.autogenerated = false;
		modMeta.credits = "";
		modMeta.description = "A Pet Buddy to feel less lonely";
		modMeta.url = "https://github.com/ArtixAllMighty/PetBuddy2016/wiki";
		
		instance = this;
		
		proxy.registerEntities();
		proxy.registerRenders();
		proxy.registerKey();
		
		NetworkRegistry.INSTANCE.registerGuiHandler(this, new GuiHandler());
		new PetInventoryCapability().register();
		new StowOrSummonLogic();
		new PlayerTracker();
		new NetworkHandler();
		new CoolDownTracker();
		
		new KeyHandler();
	}
}
